package com.mysql.jdbc.jdbc2.optional;

import com.mysql.jdbc.ConnectionImpl;
import java.sql.Connection;
import java.sql.SQLException;
import javax.sql.XAConnection;
import javax.sql.XADataSource;

/* loaded from: com_mysql_jdbc_jdbc2_optional.jar:com/mysql/jdbc/jdbc2/optional/MysqlXADataSource.class */
public class MysqlXADataSource extends MysqlDataSource implements XADataSource {
    public XAConnection getXAConnection() throws SQLException {
        Connection conn = getConnection();
        return wrapConnection(conn);
    }

    public XAConnection getXAConnection(String user, String password) throws SQLException {
        Connection conn = getConnection(user, password);
        return wrapConnection(conn);
    }

    private XAConnection wrapConnection(Connection conn) throws SQLException {
        if (getPinGlobalTxToPhysicalConnection() || ((com.mysql.jdbc.Connection) conn).getPinGlobalTxToPhysicalConnection()) {
            return new SuspendableXAConnection((ConnectionImpl) conn);
        }
        return new MysqlXAConnection((ConnectionImpl) conn, getLogXaCommands());
    }
}
